-- The default rotations generator for WARLOCKS.
local warlockRotationsGenerator = function ()
	local rotation = {
		["defaultRotation/warlock/destruction"] = {
			["version"] = 1,
			["specID"] = 3,
			["ActionList"] = {
				["defaultRotation/warlock/chaos_bolt_charred_remains"] = {
					["v_p_knowspell"] = "157696",
					["v_p_unitpowertype"] = "14",
					["b_p_unitpower"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "17877",
					["v_spellname"] = "17877",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=2.5",
				},
				["defaultRotation/warlock/conflagrate"] = {
					["b_charges"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "17962",
					["v_spellname"] = "17962",
					["v_charges"] = "1",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/warlock/chaos_bolt_execute"] = {
					["v_t_hp"] = "<10%",
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "116858",
					["b_t_hp"] = true,
					["v_spellname"] = "116858",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/warlock/dark_soul_instability"] = {
					["v_p_unitpowertype"] = "14",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "113858",
					["b_p_unitpower"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">3",
					["v_actionicon"] = "113858",
				},
				["defaultRotation/warlock/summon_demon"] = {
					["v_p_needbuff"] = "_108503",
					["b_p_needbuff"] = true,
					["v_pet_hp"] = "=0",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "475",
					["v_spellname"] = "688",
					["v_p_knowspell"] = "108503",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["b_pet_hp"] = true,
				},
				["defaultRotation/warlock/summon_terrorguard"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "18540",
					["v_p_knowspell"] = "152107&108499",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "18540",
				},
				["defaultRotation/warlock/cataclysm"] = {
					["v_p_knowspell"] = "152108",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "152108",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "152108",
				},
				["defaultRotation/warlock/incinerate"] = {
					["v_actionicon"] = "29722",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "29722",
					["v_keybind"] = "<keybind>",
				},
				["defaultRotation/warlock/immolate_cataclysm"] = {
					["v_t_needsdebuff"] = "_348^4.5",
					["v_checkothercdname"] = "152108",
					["v_p_knowspell"] = "152108",
					["v_keybind"] = "<keybind>",
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "348",
					["b_t_needsdebuff"] = true,
					["v_checkothercdvalue"] = ">4.5",
					["v_actionicon"] = "348",
				},
				["defaultRotation/warlock/chaos_bolt_dark_soul_instability"] = {
					["v_actionicon"] = "116858",
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "116858",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "113858",
				},
				["defaultRotation/warlock/chaos_bolt"] = {
					["v_actionicon"] = "116858",
					["b_p_unitpower"] = true,
					["v_durationstartedtime"] = 0,
					["b_p_knownotspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "14",
					["v_spellname"] = "116858",
					["v_p_knownotspell"] = "157696",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=3.5",
				},
				["defaultRotation/warlock/grimoire_of_sacrifice"] = {
					["v_p_needbuff"] = "_108503",
					["v_p_knowspell"] = "108503",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "108503",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "108503",
					["b_p_needbuff"] = true,
				},
				["defaultRotation/warlock/summon_doomguard_grimoire_of_service"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "18540",
					["v_p_knowspell"] = "152107&108501",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "18540",
				},
				["defaultRotation/warlock/dark_intent"] = {
					["v_p_needbuff"] = "1459||61316||109773||160205||128433||90364||126309||166916||49868||113742||172968||50519||34889||24844||57386||58604",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "109773",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "109773",
				},
				["defaultRotation/warlock/dark_regeneration"] = {
					["v_p_knowspell"] = "108359",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "108359",
					["v_actionicon"] = "108359",
					["v_keybind"] = "<keybind>",
					["v_p_hp"] = "<70%",
					["b_p_hp"] = true,
				},
				["defaultRotation/warlock/sacrificial_pact"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "108416",
					["v_p_knowspell"] = "108416",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "108416",
				},
				["defaultRotation/warlock/immolate"] = {
					["v_t_needsdebuff"] = "_348^4.5",
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "348",
					["v_spellname"] = "348",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/warlock/conflagrate_2_charges"] = {
					["b_charges"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "17962",
					["v_actionicon"] = "17962",
					["v_keybind"] = "<keybind>",
					["v_charges"] = "2",
				},
				["defaultRotation/warlock/shadowburn_charred_remains"] = {
					["v_actionicon"] = "17877",
					["v_durationstartedtime"] = 0,
					["v_p_knowspell"] = "157696",
					["v_t_hp"] = "<20%",
					["v_p_unitpowertype"] = "14",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["b_t_hp"] = true,
					["v_spellname"] = "17877",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=2.5",
				},
				["defaultRotation/warlock/summon_doomguard"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "18540",
					["v_p_knowspell"] = "152107",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "18540",
				},
				["defaultRotation/warlock/shadowburn"] = {
					["v_keybind"] = "<keybind>",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["b_t_hp"] = true,
					["b_p_unitpower"] = true,
					["v_p_knownotspell"] = "157696",
					["v_actionicon"] = "17877",
					["v_spellname"] = "17877",
					["v_p_unitpowertype"] = "14",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=3.5",
					["v_t_hp"] = "<20%",
				},
			},
			["SortedActions"] = {
				"defaultRotation/warlock/dark_intent", -- [1]
				"defaultRotation/warlock/summon_doomguard", -- [2]
				"defaultRotation/warlock/summon_terrorguard", -- [3]
				"defaultRotation/warlock/summon_doomguard_grimoire_of_service", -- [4]
				"defaultRotation/warlock/summon_demon", -- [5]
				"defaultRotation/warlock/grimoire_of_sacrifice", -- [6]
				"defaultRotation/warlock/dark_soul_instability", -- [7]
				"defaultRotation/warlock/sacrificial_pact", -- [8]
				"defaultRotation/warlock/dark_regeneration", -- [9]
				"defaultRotation/warlock/shadowburn_charred_remains", -- [10]
				"defaultRotation/warlock/shadowburn", -- [11]
				"defaultRotation/warlock/immolate_cataclysm", -- [12]
				"defaultRotation/warlock/cataclysm", -- [13]
				"defaultRotation/warlock/chaos_bolt_dark_soul_instability", -- [14]
				"defaultRotation/warlock/chaos_bolt_charred_remains", -- [15]
				"defaultRotation/warlock/chaos_bolt_execute", -- [16]
				"defaultRotation/warlock/chaos_bolt", -- [17]
				"defaultRotation/warlock/immolate", -- [18]
				"defaultRotation/warlock/conflagrate_2_charges", -- [19]
				"defaultRotation/warlock/conflagrate", -- [20]
				"defaultRotation/warlock/incinerate", -- [21]
			},
			["keybind"] = "<keybind>",
		},
		["defaultRotation/warlock/demonology"] = {
			["version"] = 1,
			["specID"] = 2,
			["ActionList"] = {
				["defaultRotation/warlock/corruption"] = {
					["v_t_needsdebuff"] = "_172^5.4",
					["b_p_needbuff"] = true,
					["v_actionicon"] = "172",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "172",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_needbuff"] = "_103958",
				},
				["defaultRotation/warlock/summmon_felguard_grimoire_of_service"] = {
					["v_p_knowspell"] = "108501",
					["b_p_knowspell"] = true,
					["v_p_knownotspell"] = "152107",
					["v_actionicon"] = "30146",
					["v_spellname"] = "30146",
					["v_togglename"] = "Toggle 1",
					["v_keybind"] = "<keybind>",
					["b_p_knownotspell"] = true,
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/warlock/soul_fire_metamorphosis_execute"] = {
					["v_actionicon"] = "6353",
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["b_t_hp"] = true,
					["v_spellname"] = "6353",
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_103958",
					["v_t_hp"] = "<25%",
				},
				["defaultRotation/warlock/soul_fire_execute"] = {
					["v_p_needbuff"] = "_103958",
					["b_p_needbuff"] = true,
					["v_actionicon"] = "6353",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "6353",
					["v_keybind"] = "<keybind>",
					["b_t_hp"] = true,
					["v_t_hp"] = "<25%",
				},
				["defaultRotation/warlock/chaos_wave"] = {
					["v_actionicon"] = "124916",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_p_knownotspell"] = "157695",
					["b_p_havebuff"] = true,
					["v_spellname"] = "105174",
					["v_togglename"] = "Toggle 1",
					["b_p_knownotspell"] = true,
					["v_p_havebuff"] = "_103985",
				},
				["defaultRotation/warlock/dark_soul_knowledge"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "113861",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "113861",
				},
				["defaultRotation/warlock/touch_of_chaos"] = {
					["v_actionicon"] = "103964",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "686",
					["v_p_havebuff"] = "_103958",
					["v_keybind"] = "<keybind>",
				},
				["defaultRotation/warlock/summon_terrorguard"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "18540",
					["v_p_knowspell"] = "152107&108499",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "18540",
				},
				["defaultRotation/warlock/shadow_bolt"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "686",
					["v_actionicon"] = "686",
					["v_keybind"] = "<keybind>",
				},
				["defaultRotation/warlock/doom"] = {
					["v_t_needsdebuff"] = "_603^18",
					["b_p_havebuff"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_knownotspell"] = true,
					["v_p_knownotspell"] = "152108",
					["v_actionicon"] = "124913",
					["v_spellname"] = "172",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_103958",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/warlock/sacrificial_pact"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "108416",
					["v_p_knowspell"] = "108416",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "108416",
				},
				["defaultRotation/warlock/cataclysm"] = {
					["v_p_knowspell"] = "152108",
					["v_actionicon"] = "152108",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "152108",
					["b_p_havebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_103958",
				},
				["defaultRotation/warlock/touch_of_chaos_demonic_fury"] = {
					["v_actionicon"] = "103964",
					["b_p_unitpower"] = true,
					["v_p_unitpower"] = ">900",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "686",
					["v_p_unitpowertype"] = "15",
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_103958",
				},
				["defaultRotation/warlock/summon_wrathguard"] = {
					["v_p_knowspell"] = "108499",
					["b_p_knowspell"] = true,
					["v_p_knownotspell"] = "152107",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "30146",
					["v_actionicon"] = "112870",
					["v_keybind"] = "<keybind>",
					["v_togglename"] = "Toggle 1",
					["b_p_knownotspell"] = true,
				},
				["defaultRotation/warlock/summon_doomguard_grimoire_of_service"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "18540",
					["v_p_knowspell"] = "152107&108501",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "18540",
				},
				["defaultRotation/warlock/hand_of_guldan_2_charges"] = {
					["v_p_needbuff"] = "_103958",
					["b_p_needbuff"] = true,
					["b_charges"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "105174",
					["v_actionicon"] = "105174",
					["v_keybind"] = "<keybind>",
					["v_charges"] = "2",
				},
				["defaultRotation/warlock/metamorphosis"] = {
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "15",
					["v_spellname"] = "103958",
					["v_actionicon"] = "103958",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "=1000",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/warlock/life_tap"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_p_unitpowertype"] = "0",
					["v_p_hp"] = ">50%",
					["b_p_unitpower"] = true,
					["v_spellname"] = "1454",
					["v_actionicon"] = "1454",
					["b_p_hp"] = true,
					["v_p_unitpower"] = "<75%",
					["v_keybind"] = "<keybind>",
				},
				["defaultRotation/warlock/touch_of_chaos_refresh"] = {
					["v_t_needsdebuff"] = "_172^3",
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "103964",
					["v_spellname"] = "686",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_103958",
				},
				["defaultRotation/warlock/summon_felguard"] = {
					["v_actionicon"] = "30146",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "30146",
					["b_p_knownotspell"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_knownotspell"] = "152107",
				},
				["defaultRotation/warlock/hand_of_guldan"] = {
					["v_t_needsdebuff"] = "_47960^2.5",
					["b_p_needbuff"] = true,
					["v_actionicon"] = "105174",
					["b_charges"] = true,
					["v_spellname"] = "105174",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_charges"] = ">=1",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_needbuff"] = "_103958",
				},
				["defaultRotation/warlock/dark_intent"] = {
					["v_p_needbuff"] = "1459||61316||109773||160205||128433||90364||126309||166916||49868||113742||172968||50519||34889||24844||57386||58604",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "109773",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "109773",
				},
				["defaultRotation/warlock/soul_fire_metamorphosis"] = {
					["b_p_havebuff"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "6353",
					["v_actionicon"] = "6353",
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_103958&_122355",
				},
				["defaultRotation/warlock/demonbolt"] = {
					["v_p_needbuff"] = "_157695#4",
					["b_p_needbuff"] = true,
					["v_p_knowspell"] = "157695",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "<spell name>",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_103958",
				},
				["defaultRotation/warlock/soul_fire_demonbolt"] = {
					["v_p_needbuff"] = "_103958",
					["b_p_needbuff"] = true,
					["b_p_havebuff"] = true,
					["v_durationstartedtime"] = 0,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "6353",
					["v_spellname"] = "6353",
					["v_p_knowspell"] = "157695",
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_122355",
				},
				["defaultRotation/warlock/dark_regeneration"] = {
					["v_p_knowspell"] = "108359",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "108359",
					["v_actionicon"] = "108359",
					["v_keybind"] = "<keybind>",
					["v_p_hp"] = "<70%",
					["b_p_hp"] = true,
				},
				["defaultRotation/warlock/touch_of_chaos_refresh_execute"] = {
					["v_t_needsdebuff"] = "_172^3",
					["v_actionicon"] = "103964",
					["b_t_hp"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "686",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_103958",
					["v_t_hp"] = "<25%",
				},
				["defaultRotation/warlock/summon_doomguard"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "18540",
					["v_p_knowspell"] = "152107",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "18540",
				},
				["defaultRotation/warlock/soul_fire"] = {
					["v_p_needbuff"] = "_103958",
					["b_p_needbuff"] = true,
					["b_p_havebuff"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "6353",
					["v_actionicon"] = "6353",
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "_122355#4",
				},
			},
			["SortedActions"] = {
				"defaultRotation/warlock/dark_intent", -- [1]
				"defaultRotation/warlock/summon_doomguard", -- [2]
				"defaultRotation/warlock/summon_terrorguard", -- [3]
				"defaultRotation/warlock/summon_doomguard_grimoire_of_service", -- [4]
				"defaultRotation/warlock/summon_felguard", -- [5]
				"defaultRotation/warlock/summon_wrathguard", -- [6]
				"defaultRotation/warlock/summmon_felguard_grimoire_of_service", -- [7]
				"defaultRotation/warlock/dark_soul_knowledge", -- [8]
				"defaultRotation/warlock/sacrificial_pact", -- [9]
				"defaultRotation/warlock/dark_regeneration", -- [10]
				"defaultRotation/warlock/life_tap", -- [11]
				"defaultRotation/warlock/metamorphosis", -- [12]
				"defaultRotation/warlock/touch_of_chaos_refresh_execute", -- [13]
				"defaultRotation/warlock/soul_fire_metamorphosis_execute", -- [14]
				"defaultRotation/warlock/cataclysm", -- [15]
				"defaultRotation/warlock/doom", -- [16]
				"defaultRotation/warlock/demonbolt", -- [17]
				"defaultRotation/warlock/touch_of_chaos_refresh", -- [18]
				"defaultRotation/warlock/touch_of_chaos_demonic_fury", -- [19]
				"defaultRotation/warlock/soul_fire_metamorphosis", -- [20]
				"defaultRotation/warlock/touch_of_chaos", -- [21]
				"defaultRotation/warlock/corruption", -- [22]
				"defaultRotation/warlock/chaos_wave", -- [23]
				"defaultRotation/warlock/hand_of_guldan_2_charges", -- [24]
				"defaultRotation/warlock/hand_of_guldan", -- [25]
				"defaultRotation/warlock/soul_fire_demonbolt", -- [26]
				"defaultRotation/warlock/soul_fire_execute", -- [27]
				"defaultRotation/warlock/soul_fire", -- [28]
				"defaultRotation/warlock/shadow_bolt", -- [29]
			},
			["keybind"] = "<keybind>",
		},
		["defaultRotation/warlock/affliction"] = {
			["version"] = 1,
			["specID"] = 1,
			["ActionList"] = {
				["defaultRotation/warlock/corruption"] = {
					["v_t_needsdebuff"] = "_172^5.4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "172",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "172",
				},
				["defaultRotation/warlock/haunt_execute"] = {
					["v_t_hp"] = "<10%",
					["v_togglename"] = "Toggle 1",
					["b_p_knownotspell"] = true,
					["v_p_knownotspell"] = "152109",
					["v_actionicon"] = "48181",
					["b_t_hp"] = true,
					["v_spellname"] = "48181",
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/warlock/summon_demon"] = {
					["v_p_needbuff"] = "_108503",
					["b_p_needbuff"] = true,
					["v_actionicon"] = "475",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "688",
					["v_p_knowspell"] = "108503",
					["v_keybind"] = "<keybind>",
					["v_pet_hp"] = "=0",
					["b_pet_hp"] = true,
				},
				["defaultRotation/warlock/haunt_soulburn_haunt"] = {
					["b_t_hasdebuff"] = true,
					["v_p_knowspell"] = "152109",
					["v_actionicon"] = "48181",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "48181",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "74434",
					["v_t_hasdebuff"] = "_980&_172&_30108",
				},
				["defaultRotation/warlock/summon_doomguard"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "18540",
					["v_p_knowspell"] = "152107",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "18540",
				},
				["defaultRotation/warlock/summon_terrorguard"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "18540",
					["v_p_knowspell"] = "152107&108499",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "18540",
				},
				["defaultRotation/warlock/unstable_affliction"] = {
					["v_t_needsdebuff"] = "_30108^4.2",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "30108",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "30108",
				},
				["defaultRotation/warlock/drain_soul"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "103103",
					["v_actionicon"] = "103103",
					["v_keybind"] = "<keybind>",
				},
				["defaultRotation/warlock/agony"] = {
					["v_t_needsdebuff"] = "_980^7.2",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "980",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "980",
				},
				["defaultRotation/warlock/dark_regeneration"] = {
					["v_p_knowspell"] = "108359",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "108359",
					["v_p_hp"] = "<70%",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "108359",
					["b_p_hp"] = true,
				},
				["defaultRotation/warlock/soulburn"] = {
					["v_p_needbuff"] = "157698^9",
					["v_actionicon"] = "74434",
					["b_t_hasdebuff"] = true,
					["b_p_needbuff"] = true,
					["v_durationstartedtime"] = 0,
					["v_p_knowspell"] = "152109",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "7",
					["v_spellname"] = "74434",
					["b_p_unitpower"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=2",
					["v_t_hasdebuff"] = "_980&_172&_30108",
				},
				["defaultRotation/warlock/sacrificial_pact"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "108416",
					["v_p_knowspell"] = "108416",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "108416",
				},
				["defaultRotation/warlock/life_tap"] = {
					["v_actionicon"] = "1454",
					["v_p_hp"] = ">50%",
					["v_p_unitpowertype"] = "0",
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "1454",
					["v_durationstartedtime"] = 0,
					["b_p_hp"] = true,
					["v_p_unitpower"] = "<75%",
					["v_keybind"] = "<keybind>",
				},
				["defaultRotation/warlock/grimoire_of_sacrifice"] = {
					["v_p_needbuff"] = "_108503",
					["v_p_knowspell"] = "108503",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "108503",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "108503",
					["b_p_needbuff"] = true,
				},
				["defaultRotation/warlock/haunt_dark_soul_misery"] = {
					["v_actionicon"] = "48181",
					["v_durationstartedtime"] = 0,
					["v_p_knownotspell"] = "152109",
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "48181",
					["b_p_knownotspell"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "113860",
				},
				["defaultRotation/warlock/summon_doomguard_grimoire_of_service"] = {
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "18540",
					["v_p_knowspell"] = "152107&108501",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "18540",
				},
				["defaultRotation/warlock/dark_intent"] = {
					["v_p_needbuff"] = "1459||61316||109773||160205||128433||90364||126309||166916||49868||113742||172968||50519||34889||24844||57386||58604",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "109773",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "109773",
				},
				["defaultRotation/warlock/soul_swap"] = {
					["v_t_needsdebuff"] = "_980&_172&_30108",
					["v_actionicon"] = "86121",
					["b_p_havebuff"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "86121",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "74434",
				},
				["defaultRotation/warlock/haunt_soulburn_haunt_dark_soul_misery"] = {
					["b_p_havebuff"] = true,
					["b_p_unitpower"] = true,
					["v_p_knowspell"] = "152109",
					["v_durationstartedtime"] = 0,
					["v_p_unitpower"] = ">=3",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "48181",
					["v_spellname"] = "48181",
					["v_p_unitpowertype"] = "7",
					["v_keybind"] = "<keybind>",
					["v_p_havebuff"] = "113860",
				},
				["defaultRotation/warlock/haunt_soul_shards_4"] = {
					["v_p_unitpowertype"] = "7",
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "48181",
					["v_spellname"] = "48181",
					["b_p_unitpower"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=4",
				},
				["defaultRotation/warlock/haunt_soul_shards_3"] = {
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["b_p_knownotspell"] = true,
					["v_durationstartedtime"] = 0,
					["v_p_knownotspell"] = "152109",
					["v_actionicon"] = "48181",
					["v_spellname"] = "48181",
					["v_p_unitpowertype"] = "7",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=3",
				},
				["defaultRotation/warlock/dark_soul_misery"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "113860",
					["v_keybind"] = "<keybind>",
					["v_actionicon"] = "113860",
				},
				["defaultRotation/warlock/haunt"] = {
					["v_t_needsdebuff"] = "_48181",
					["v_actionicon"] = "48181",
					["b_p_knownotspell"] = true,
					["v_p_knownotspell"] = "152109",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "48181",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_togglename"] = "Toggle 1",
				},
				["defaultRotation/warlock/soulburn_opening"] = {
					["v_t_needsdebuff"] = "_980&_172&_30108",
					["v_togglename"] = "Toggle 1",
					["v_actionicon"] = "74434",
					["v_spellname"] = "74434",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
				},
			},
			["SortedActions"] = {
				"defaultRotation/warlock/soul_swap", -- [1]
				"defaultRotation/warlock/haunt_soulburn_haunt", -- [2]
				"defaultRotation/warlock/dark_intent", -- [3]
				"defaultRotation/warlock/summon_doomguard", -- [4]
				"defaultRotation/warlock/summon_terrorguard", -- [5]
				"defaultRotation/warlock/summon_doomguard_grimoire_of_service", -- [6]
				"defaultRotation/warlock/summon_demon", -- [7]
				"defaultRotation/warlock/grimoire_of_sacrifice", -- [8]
				"defaultRotation/warlock/soulburn_opening", -- [9]
				"defaultRotation/warlock/agony", -- [10]
				"defaultRotation/warlock/corruption", -- [11]
				"defaultRotation/warlock/unstable_affliction", -- [12]
				"defaultRotation/warlock/dark_soul_misery", -- [13]
				"defaultRotation/warlock/sacrificial_pact", -- [14]
				"defaultRotation/warlock/dark_regeneration", -- [15]
				"defaultRotation/warlock/life_tap", -- [16]
				"defaultRotation/warlock/soulburn", -- [17]
				"defaultRotation/warlock/haunt_soulburn_haunt_dark_soul_misery", -- [18]
				"defaultRotation/warlock/haunt", -- [19]
				"defaultRotation/warlock/haunt_soul_shards_4", -- [20]
				"defaultRotation/warlock/haunt_execute", -- [21]
				"defaultRotation/warlock/haunt_dark_soul_misery", -- [22]
				"defaultRotation/warlock/haunt_soul_shards_3", -- [23]
				"defaultRotation/warlock/drain_soul", -- [24]
			},
			["keybind"] = "<keybind>",
		},
	}

	return rotation;
end

local warlockRotationsGeneratorData = {
	["generator"] = warlockRotationsGenerator
};

RotationBuilder:addDefaultRotationsGenerator("WARLOCK", warlockRotationsGeneratorData);